	include "bomber89.h"

	xdef _library
	xdef _ti89     ; Include if library is designed to run on TI-89

	xdef bomblib@0000	;these need to be in order!
	xdef bomblib@0001
	xdef bomblib@0002
	xdef bomblib@0003
	xdef bomblib@0004
	xdef bomblib@0005
	xdef bomblib@0006
	xdef bomblib@0007
	xdef bomblib@0008
	xdef bomblib@0009
	xdef bomblib@000A
	xdef bomblib@000B
	xdef bomblib@000C
	xdef bomblib@000D
	xdef bomblib@000E
	xdef bomblib@000F
	xdef bomblib@0010
	xdef bomblib@0011
	xdef bomblib@0012
	xdef bomblib@0013
	xdef bomblib@0014
	xdef bomblib@0015
	xdef bomblib@0016
	xdef bomblib@0017
	xdef bomblib@0018
	xdef bomblib@0019
	xdef bomblib@001A
	xdef bomblib@001B
	xdef bomblib@001C
	xdef bomblib@001D
	xdef bomblib@001E
	xdef bomblib@001F
	xdef bomblib@0020
	xdef bomblib@0021
	xdef bomblib@0022
	xdef bomblib@0023
	xdef bomblib@0024
	xdef bomblib@0025
	xdef bomblib@0026
	xdef bomblib@0027
	xdef bomblib@0028
	xdef bomblib@0029
	xdef bomblib@002A
	xdef bomblib@002B
	xdef bomblib@002C
	xdef bomblib@002D
	xdef bomblib@002E
	xdef bomblib@002F
	xdef bomblib@0030
	xdef bomblib@0031
	xdef bomblib@0032
	xdef bomblib@0033
	xdef bomblib@0034
	xdef bomblib@0035
	xdef bomblib@0036
	xdef bomblib@0037
	xdef bomblib@0038
	xdef bomblib@0039
	xdef bomblib@003A
	xdef bomblib@003B
	xdef bomblib@003C
	xdef bomblib@003D
	xdef bomblib@003E
	xdef bomblib@003F
	xdef bomblib@0040
	xdef bomblib@0041
	xdef bomblib@0042
	xdef bomblib@0043
	xdef bomblib@0044
	xdef bomblib@0045
	xdef bomblib@0046
	xdef bomblib@0047
	xdef bomblib@0048
	xdef bomblib@0049
	xdef bomblib@004A
	xdef bomblib@004B
	xdef bomblib@004C
	xdef bomblib@004D
	xdef bomblib@004E
	xdef bomblib@004F
	xdef bomblib@0050
	xdef bomblib@0051
	xdef bomblib@0052
	xdef bomblib@0053
	xdef bomblib@0054

	include "macros.asm"		;includes some required macros
	include "enemy1_proc_lib.asm"	;contains some if the code for handling enemy1
	include "enemy2_proc_lib.asm"	;contains some if the code for handling enemy2
	include "high_score_lib.asm"	;contains code for checking and displayiong high scores
	include "sprite_lib.asm"	;contains some sprites(like the title
;**********************************END OF HEADER

;bomblib@0000:		;slots @0000 through @0010 are saved for function use
;bomblib@0001:		;currently, only @0000 through @0007 are used
;bomblib@0002:
;bomblib@0003:
;bomblib@0004:
;bomblib@0005:
;bomblib@0006:
;bomblib@0007:
bomblib@0008:
bomblib@0009:
bomblib@000A:
bomblib@000B:
bomblib@000C:
bomblib@000D:
bomblib@000E:
bomblib@000F:
bomblib@0010:

bomblib@0021:		;nothing

bomblib@0011:			;this is the bomber board, it contains the board data
board		ds.b 280

bomblib@0012:			;this is the enemy1_x array, containing x-coordinates 
enemy1_x	ds.b 50
bomblib@0013:			;this is the enemy1_y array, containing y-coordinates 
enemy1_y	ds.b 50
bomblib@0014:			;this is the enemy1_d array, containing enemy directions
enemy1_d	ds.b 50
bomblib@0015:			;this is the enemy1_s array, containing corrent sprite data
enemy1_s	ds.b 50

bomblib@0016:			;this is the enemy2_x array, containing x-coordinates
enemy2_x	ds.b 50
bomblib@0017:			;this is the enemy2_y array, containing y-coordinates 
enemy2_y	ds.b 50
bomblib@0018:			;this is the enemy2_d array, containing enemy directions
enemy2_d	ds.b 50
bomblib@0019:			;this is the enemy2_s array, containing corrent sprite data
enemy2_s	ds.b 50

bomblib@001A:			;this is the bomb_x array, containing x-coordinates
bomb_x		ds.b 40
bomblib@001B:			;this is the bomb_y array, containing y-coordinates 
bomb_y		ds.b 40
bomblib@001C:			;this is the bomb_s array, containing time to death info
bomb_s		ds.b 40
bomblib@001D:			;this is the bomb_es array, containing current sprite data
bomb_es		ds.b 40

bomblib@001E:			;this is the hexp_x array, containing x-coordinates
hexp_x		ds.b 100
bomblib@001F:			;this is the hexp_y array, containing y-coordinates 
hexp_y		ds.b 100
bomblib@0020:			;this is the hexp_s array, containing current sprite data
hexp_s		ds.b 100

bomblib@0022:			;this is the vexp_x array, containing x-coordinates
vexp_x		ds.b 100
bomblib@0023:			;this is the vexp_y array, containing y-coordinates 
vexp_y		ds.b 100
bomblib@0024:			;this is the vexp_s array, containing current sprite data
vexp_s		ds.b 100

bomblib@0025:			;this is the xexp_x array, containing x-coordinates
xexp_x		ds.b 100
bomblib@0026:			;this is the xexp_y array, containing y-coordinates 
xexp_y		ds.b 100
bomblib@0027:			;this is the xexp_s array, containing current sprite data
xexp_s		ds.b 100

bomblib@004E:			;this is the bexp_x array, containing x-coordinates
bexp_x		ds.b 100
bomblib@004F:			;this is the bexp_y array, containing y-coordinates 
bexp_y		ds.b 100
bomblib@0050:			;this is the bexp_s array, containing current sprite data
bexp_s		ds.b 100

bomblib@0028:			;this is the bonus_x array, containing x-coordinates
bonus_x		ds.b 20
bomblib@0029:			;this is the bonus_y array, containing y-coordinates 
bonus_y		ds.b 20
bomblib@002A:			;this is the bonus_t array, containing the bonus type
bonus_t		ds.b 20

bomblib@002B:			;this contains the possibility that a bonus will try to be placed
bonus_possibility dc.w 20

bomblib@0043:			;the value that t_to_key gets reset to when it decreases to 0
def_t_to_key	dc.w 16

bomblib@004C:			;1 is the player can walk through bombs
walk_through_bombs	dc.w 0
bomblib@004D:			;1 is the player can walk through walls
walk_through_walls	dc.w 0
bomblib@0044:			;1 is the player has remote bombs
trigger_bombs	dc.w 0
bomblib@002C:			;1 if the game is counting down to its termination
count_down_flag	dc.w 20
bomblib@002D:			;starts at 100 and decreases until the game ends at 0
count_down_n	dc.w 0
bomblib@002E:			;set to the reason the game is ending, (death or win)
count_down_reason dc.w 0
bomblib@002F:			;the amount of enemy1s in the enemy1 arrays
enemy1count 	dc.w 0
bomblib@0030:			;the amount of enemy2s in the enemy2 arrays
enemy2count 	dc.w 0
bomblib@0031:			;the amount of bombs in the bomb arrays
bombcount 	dc.w 0
bomblib@0032:			;the amount of hexps in the hexp arrays
hexpcount 	dc.w 0
bomblib@0033:			;the amount of vexps in the vexp arrays
vexpcount 	dc.w 0
bomblib@0034:			;the amount of xexps in the xexp arrays
xexpcount 	dc.w 0
bomblib@0051:			;the amount of bexps in the bexp arrays
bexpcount 	dc.w 0
bomblib@0035:			;the amount of bonuses in the bonus arrays
bonuscount 	dc.w 0
bomblib@0036:			;the x-coord of the player in pixels
plx		dc.w 5
bomblib@0037:			;the y-coord of the player in pixels
ply		dc.w 5
bomblib@0045:			;the old x-coord of the player in pixels
oldx		dc.w 5
bomblib@0046:			;the old y-coord of the player in pixels
oldy		dc.w 5
bomblib@0047:			;the time until the player reverts to a standing position
time_to_stand	dc.w 0		;after he has stopped moving
bomblib@0048:			;the current level of the player sprite (nonzero when walking)
spritelevel	dc.w 0
bomblib@0049:			;the old direction the player was facing
oldoldmove	dc.w 0
bomblib@004A:			;the old level of the player sprite
oldspritelevel  dc.w 0
bomblib@0054:			;the direction the player is currently facing
oldmove		dc.w 0

bomblib@0038:			;one if a saved game is stored
saved_game	dc.w 0

bomblib@0039:			;the level of game difficulty, increasing every 3 levels
game_difficulty dc.w 0
bomblib@004B:			;the value that t_to_APD gets reset to when it decreases to 0
def_t_to_APD	dc.w 10

bomblib@003A:			;the player's score (0 to 999)
score		dc.w 0
bomblib@003B:			;the player's score (1,000-999,000)
scoreh		dc.w 0
bomblib@003C:			;the score the player had last loop (compares to see if
old_score	dc.w 0		;the score should be re-drawn
bomblib@003D:			;the player's current level
level		dc.w 0

bomblib@003E:			;how long bombs stay on the screen before they explode
bomblife	dc.w 30
bomblib@003F:			;the current length of the bombs in each angle
bomb_exp_len	dc.w 1
bomblib@0040:			;how long an explosion explodes (constant)
explife		dc.w 5
bomblib@0041:			;how many total bombs are allowed
bombsallowed	dc.w 1

bomblib@0042:			;the players extra life (0-4)
pllife		dc.w 4

name		dc.b "----------",0,0	;a temperary name value
high_score1	dc.b "----------",0,0	;the name of the top scorer
high_score2	dc.b "----------",0,0	;the name of the 2nd scorer
high_score3	dc.b "----------",0,0	;the name of the 3rd scorer
high_score4	dc.b "----------",0,0	;the name of the 4th scorer
high_score5	dc.b "----------",0,0	;the name of the 5th scorer
high_score6	dc.b "----------",0,0	;the name of the 6th scorer
high_score7	dc.b "----------",0,0	;the name of the 7th scorer
high_score8	dc.b "----------",0,0	;the name of the 8th scorer
high_score1n	dc.w 0	;a high scorer's score from 1-999
high_score2n	dc.w 0	;a high scorer's score from 1-999
high_score3n	dc.w 0	;a high scorer's score from 1-999
high_score4n	dc.w 0	;a high scorer's score from 1-999
high_score5n	dc.w 0	;a high scorer's score from 1-999
high_score6n	dc.w 0	;a high scorer's score from 1-999
high_score7n	dc.w 0	;a high scorer's score from 1-999
high_score8n	dc.w 0	;a high scorer's score from 1-999
high_score1l	dc.w 0	;a high scorer's reached level
high_score2l	dc.w 0	;a high scorer's reached level
high_score3l	dc.w 0	;a high scorer's reached level
high_score4l	dc.w 0	;a high scorer's reached level
high_score5l	dc.w 0	;a high scorer's reached level
high_score6l	dc.w 0	;a high scorer's reached level
high_score7l	dc.w 0	;a high scorer's reached level
high_score8l	dc.w 0	;a high scorer's reached level
high_score1h	dc.w 0	;a high scorer's score from 1,000-999,000
high_score2h	dc.w 0a high scorer's score from 1,000-999,000
high_score3h	dc.w 0a high scorer's score from 1,000-999,000
high_score4h	dc.w 0a high scorer's score from 1,000-999,000
high_score5h	dc.w 0a high scorer's score from 1,000-999,000
high_score6h	dc.w 0a high scorer's score from 1,000-999,000
high_score7h	dc.w 0a high scorer's score from 1,000-999,000
high_score8h	dc.w 0a high scorer's score from 1,000-999,000

x	dc.l	0	;temporary x-value
y	dc.l	0	;temporary y-value
d	dc.l	0	;temporary direction
s	dc.l	0	;temporary sprite value
es	dc.l	0	;temporary extended sprite value
dir	dc.l	0	;temporary direction

	;****shows position information for a bomb, explosion, bonus, enemy
eblock_x	dc.w 0		;the current square (there are 13) that the extra is on
eblock_y	dc.w 0		;the current square (there are 10) that the extra is on
erelpos_x	dc.w 0		;the position of the extra in a square (1-9), 5 is middle
erelpos_y	dc.w 0		;the position of the extra in a square (1-9), 5 is middle

score1y		dc.w	86	;the y position of a score (only for displaying in main screen)
score2y		dc.w	94	;the y position of a score (only for displaying in main screen)
score3y		dc.w	102	;the y position of a score (only for displaying in main screen)
score4y		dc.w	110	;the y position of a score (only for displaying in main screen)
score5y		dc.w	118	;the y position of a score (only for displaying in main screen)
score6y		dc.w	126	;the y position of a score (only for displaying in main screen)
score7y		dc.w	134	;the y position of a score (only for displaying in main screen)
score8y		dc.w	72	;the y position of a score (only for displaying in main screen)

zero			dc.b	"0",0
random_level_char		dc.b	'R',0

number1_text	dc.b	"1 ",0,0
number2_text	dc.b	"2 ",0,0
number3_text	dc.b	"3 ",0,0
number4_text	dc.b	"4 ",0,0
number5_text	dc.b	"5 ",0,0
number6_text	dc.b	"6 ",0,0
number7_text	dc.b	"7 ",0,0
number8_text	dc.b	"8 ",0,0

high_score_text			dc.b	"High Score",0,0
ask_name_text			dc.b	"Enter Your Name",0

;*******************************CONVERT D0 TO A STRING
;*
;*	Used for print_d0 macro
;*
;********
ConvStr:
    movem.l d0-d2,-(a7)
    clr.b   (a0)
conv_repeat:
    divu    #10,d0
    move.l  d0,d2
    swap    d2
    add.b   #48,d2
    move.b  d2,-(a0)
    subq    #1,d1
    and.l   #$FFFF,d0
    bne     conv_repeat
    tst.w   d1
    beq     conv_done
    subq    #1,d1
fillout:
    move.b  #32,-(a0)
    dbra    d1,fillout
conv_done:
    movem.l (a7)+,d0-d2
    rts

str             ds.b 16
strend

	END