;this macro generates a code block that is used for displaying the high scores
;(  I know its very inneficient and space covering:(  )
GenetateScoreDisplayingCode MACRO
	sil_disp_score\1:
	subq.w		#1,score\1y
	cmp.w		#71,score\1y
	ble			sil_displayed_score\1_reset
	bra			sil_displayed_score\1_no_reset
	sil_displayed_score\1_reset:
	move.w	#0,d0
	move.w	score\1y,d1
	move.w	#160,d2
	move.w	#8,d3
	moveq.w	#1,d4
	move.l	graphlib::plane0,a1
	jsr	graphlib::fill
	move.l	graphlib::plane1,a1
	jsr	graphlib::fill
	move.w		#141,score\1y
	sil_displayed_score\1_no_reset:
	cmp.w		#100,score\1y
	bhi			sil_displayed_score\1
	move.w	#0,d0
	move.w	score\1y,d1
	move.w	#160,d2
	move.w	#8,d3
	moveq.w	#1,d4
	move.l	graphlib::plane0,a1
	jsr	graphlib::fill
	move.l	graphlib::plane1,a1
	jsr	graphlib::fill
	WriteStrL	#10,score\1y,#1,high_score\1
	cmp.w	#10,high_score\1n
	bcc		high_score\1_greater_ten
	WriteStr	#98,score\1y,#1,zero
	high_score\1_greater_ten:
	cmp.w	#100,high_score\1n
	bcc		high_score\1_greater_hundred
	WriteStr	#92,score\1y,#1,zero
	high_score\1_greater_hundred:
	cmp.w	#10,high_score\1h
	bcc		high_score\1h_greater_ten
	WriteStr	#80,score\1y,#1,zero
	high_score\1h_greater_ten:
	cmp.w	#100,high_score\1h
	bcc		high_score\1h_greater_hundred
	WriteStr	#74,score\1y,#1,zero
	high_score\1h_greater_hundred:
	move.w	high_score\1n,d0
	print_d0	#92,score\1y,#1
	move.w	high_score\1h,d0
	print_d0	#74,score\1y,#1
	cmp.w		#0,high_score\1l
	beq			sil_displayed_score\1_random
	move.w		high_score\1l,d0
	print_d0	#120,score\1y,#1
	bra			sil_displayed_score\1_no_random
	sil_displayed_score\1_random:
	WriteStr	#132,score\1y,#1,random_level_char
	sil_displayed_score\1_no_random:
	move.w		#1,d0
	WriteStr	#1,score\1y,#1,number\1_text
	bra		sil_displayed_score\1
	ENDM

;fill a box
Fill MACRO			;x,y,width,height,color
	move.w	\1,d0
	move.w	\2,d1
	move.w	\3,d2
	move.w	\4,d3
	moveq.w	\5,d4
	move.l	graphlib::plane0,a1
	jsr	graphlib::fill
	move.l	graphlib::plane1,a1
	jsr	graphlib::fill
	ENDM

;write a message in a box
Message	MACRO			;title string,center string,x coord of center string
	move.l	a0,-(a7)
	lea		\1,a0
	move.l	graphlib::plane1,a1	;adress of the 2nd bitplane
	jsr		graphlib::smallbox
	lea		\1,a0
	move.l	graphlib::plane0,a1	;adress of the 2nd bitplane
	jsr		graphlib::smallbox
	WriteStr	\3,#50,#1,\2
	move.l	(a7)+,a0
	ENDM

;copy a string to another
CopyStr MACRO				;sourcestr, deststr, length
	move.l		a0,-(a7)
	move.l		\3,-(a7)
	lea		\1,a0
	move.l		a0,-(a7)
	lea		\2,a0
	move.l		a0,-(a7)
	jsr		tios::strncpy
	lea		12(a7),a7
	move.l		(a7)+,a0
	ENDM

;print the content of d0 on the screen
print_d0 MACRO				;x,y,color
    lea     strend(PC),a0
    move.w  #3,d1
    bsr     ConvStr
    move.w  \3,-(a7)
    move.l  a0,-(a7)
    move.w  \2,-(a7)
    move.w  \1,-(a7)
    jsr     tios::DrawStrXY
    lea     10(a7),a7
    ENDM

WriteStr MACRO					; x,y,property,string
	move.w		\3,-(a7)
	pea			\4(pc)
	move.w		\2,-(a7)
	move.w		\1,-(a7)
	jsr		tios::DrawStrXY
	lea		10(a7),a7
	ENDM

WriteStrL MACRO					; x,y,property,lib::string
	move.w		\3,-(a7)
	pea		\4
	move.w		\2,-(a7)
	move.w		\1,-(a7)
	jsr		tios::DrawStrXY
	lea		10(a7),a7
	ENDM

WriteStrA MACRO					; x,y,property,Ax
	move.w		\3,-(a7)
	move.l		\4,-(a7)
	move.w		\2,-(a7)
	move.w		\1,-(a7)
	jsr		tios::DrawStrXY
	lea		10(a7),a7
	ENDM

WriteChar  MACRO				; x,y,property,char
	move.w		#$00FF,-(a7)
	move.w		#$0000,-(a7)
	move.w		#$00FF,-(a7)
	move.w		\3,-(a7)
	move.w		\2,-(a7)
	move.w		\1,-(a7)
	move.w		\4,-(a7)
	jsr		tios::DrawCharXY
	lea		14(a7),a7
	ENDM

SetFont MACRO					; number (0 is small, 1 is medium, 2 is large)
	move.w		\1,-(a7)
	jsr		tios::FontSetSys	; set the font
	add.l		#2,a7			; clean up the stack
	ENDM

SetBoard MACRO				;variable to set board with (d0,d1)
	move.l	a1,-(a7)
	move.l	d5,-(a7)
	;lea	board(PC),a1
	lea	bomblib::board,a1
	move.w	d0,d5
	mulu.w	#10,d5
	add.w	d1,d5
	mulu.w	#2,d5
	lea	0(a1,d5.w),a1
	move.w	\1,(a1)
	move.l	(a7)+,d5
	move.l	(a7)+,a1
	ENDM

GetBoard MACRO  			;variable to set board value(d0,d1)
	move.l	a1,-(a7)
	move.l	d5,-(a7)
	;lea	board(PC),a1
	lea	bomblib::board,a1
	move.w	d0,d5
	mulu.w	#10,d5
	add.w	d1,d5
	mulu.w	#2,d5
	lea	0(a1,d5.w),a1
	move.w	(a1),\1
	move.l	(a7)+,d5
	move.l	(a7)+,a1
	ENDM

GetBoardL MACRO  			;variable to set (d0,d1)
	move.l	a1,-(a7)
	move.l	d5,-(a7)
	lea	board(PC),a1
	;lea	bomblib::board,a1
	move.w	d0,d5
	mulu.w	#10,d5
	add.w	d1,d5
	mulu.w	#2,d5
	lea	0(a1,d5.w),a1
	move.w	(a1),\1
	move.l	(a7)+,d5
	move.l	(a7)+,a1
	ENDM

PutGray4Sprite MACRO			;sprt0,sprt1,x,y
	movem.l	d0-d1,-(a7)
	move.l	graphlib::plane0,a1	;adress of the 1st bitplane
	move.w	\3,d0
	move.w	\4,d1
	move.l	#\1,a0
	jsr	graphlib::put_sprite
	move.l	graphlib::plane1,a1	;adress of the 1st bitplane
	move.w	\3,d0
	move.w	\4,d1
	move.l	#\2,a0
	jsr	graphlib::put_sprite
	movem.l (a7)+,d0-d1
	ENDM

PutGray4SpriteAL MACRO			;lib::sprt0,lib::sprt1,x,y
	movem.l	d0-d1,-(a7)
	move.l	graphlib::plane0,a1	;adress of the 1st bitplane
	move.w	\3,d0
	move.w	\4,d1
	lea	\1,a0
	jsr	graphlib::put_sprite
	move.l	graphlib::plane1,a1	;adress of the 1st bitplane
	move.w	\3,d0
	move.w	\4,d1
	lea	\2,a0
	jsr	graphlib::put_sprite
	movem.l (a7)+,d0-d1
	ENDM

PutGray4SpriteMask MACRO			;sprt0,sprt1,mask,x,y
	movem.l	d0-d1,-(a7)
	move.l	graphlib::plane0,a1	;adress of the 1st bitplane
	move.w	\4,d0
	move.w	\5,d1
	move.l	#\1,a0
	move.b	\3,d3
	jsr	graphlib::put_sprite_mask
	move.l	graphlib::plane1,a1	;adress of the 1st bitplane
	move.w	\4,d0
	move.w	\5,d1
	move.l	#\2,a0
	jsr	graphlib::put_sprite_mask
	movem.l (a7)+,d0-d1
	ENDM

;returns random integer from 0 to total
Random MACRO				;total, variable to set
	move.l  d0,-(a7)
	move.w	\1,d0
	jsr	userlib::random
	move.w	d0,\2
	move.l	(a7)+,d0
	ENDM

;from x and y, find the block_x, block_y, relpos_y, relpos_x
SetPosInfo MACRO			;x,y
	movem.l	d0-d1,-(a7)
	clr.l	d0
	move.w	\1,d0
	subq.w	#1,d0
	divu.w	#9,d0
	clr.l	d1
	move.w	d0,d1
	move.w	d1,block_x
	clr.l	d0
	move.w	\2,d0
	subq.w	#1,d0
	divu.w	#9,d0
	clr.l	d1
	move.w	d0,d1
	move.w	d1,block_y
	clr.l	d0
	move.w	\1,d0
	move.w	block_x,d1
	mulu.w	#9,d1
	sub.w	d1,d0
	move.w	d0,relpos_x
	clr.l	d0
	move.w	\2,d0
	move.w	block_y,d1
	mulu.w	#9,d1
	sub.w	d1,d0
	move.w	d0,relpos_y
	movem.l	(a7)+,d0-d1
	ENDM

;from x and y, find the eblock_x, eblock_y, erelpos_y, erelpos_x
SetExtraPosInfo MACRO			;x,y
	movem.l	d0-d1,-(a7)
	clr.l	d0
	move.w	\1,d0
	subq.w	#1,d0
	divu.w	#9,d0
	clr.l	d1
	move.w	d0,d1
	move.w	d1,eblock_x
	clr.l	d0
	move.w	\2,d0
	subq.w	#1,d0
	divu.w	#9,d0
	clr.l	d1
	move.w	d0,d1
	move.w	d1,eblock_y
	clr.l	d0
	move.w	\1,d0
	move.w	eblock_x,d1
	mulu.w	#9,d1
	sub.w	d1,d0
	move.w	d0,erelpos_x
	clr.l	d0
	move.w	\2,d0
	move.w	eblock_y,d1
	mulu.w	#9,d1
	sub.w	d1,d0
	move.w	d0,erelpos_y
	movem.l	(a7)+,d0-d1
	ENDM

;get the keyboard data at position(key) and set it into d0
GetKeyStat MACRO				; key
	move.w		#$FFFE,d0
	move.b		\1,d1
	rol.w		d1,d0
	move.w		d0,($600018)
	nop
	nop
	nop
	nop
	nop
	nop
	move.b		($60001B),d0
	ENDM