;*******************************************Variables
;
;	Variable file, containes some unsaved variables that are usually temporary
;	Also containes routines to reset the variables each level or each game
;
;********

	;****these represents ratios of when certain code are called, they are subtracted
	;****by one every mainloop until they are 0, wherein the code is run and they 
	;****are reset to their according def_t_to_ variable
t_to_APD	dc.w	8	;time until the game time is resynched
t_to_key	dc.w	5	;time until a key press is accepted
t_to_handle	dc.w	10	;time until bombs, enemies, explosions, bonuses are handled
t_to_collision 	dc.w	15	;time until collisions are checked

def_t_to_APD	dc.w	10	;default time until the game time is resynched
;def_t_to_key is found in bomblib for saving
def_t_to_handle	dc.w	23	;default time until bombs, enemies, explosions, bonuses are handled
def_t_to_collision dc.w	40	;default time until collisions are checked

	;****these are immediate variables, only temperary
x		dc.l 0		;x, just a variable that represents a coordinate
y		dc.l 0		;y, just a variable that represents a coordinate
s		dc.l 0		;s, sometimes used to hold current sprite data
t		dc.l 0		;t, used to show some kind of countdown in something
es		dc.l 0		;es, sometimes used to hold current (extended) sprite data
dir		dc.l 0		;dir, used to show direction of something
tmp		dc.l 0		;tmp, used to show a temporary value
tmp2		dc.l 0		;tmp2, used to show a temporary value
a		dc.l 0		;a, used to show a temporary value
b		dc.l 0		;b, used to show a temporary value
c		dc.l 0		;c, used to show a temporary value
d		dc.l 0		;d, used to show a temporary value

	;****shows position information for ther player
block_x		dc.w 0		;the current square (there are 13) that the player is on
block_y		dc.w 0		;the current square (there are 10) that the player is on
relpos_x	dc.w 0		;the position of the sprite in a square (1-9), 5 is middle
relpos_y	dc.w 0		;the position of the sprite in a square (1-9), 5 is middle

	;****shows position information for a bomb, explosion, bonus, enemy
eblock_x	dc.w 0		;the current square (there are 13) that the extra is on
eblock_y	dc.w 0		;the current square (there are 10) that the extra is on
erelpos_x	dc.w 0		;the position of the extra in a square (1-9), 5 is middle
erelpos_y	dc.w 0		;the position of the extra in a square (1-9), 5 is middle

	;****contains key info (temporary) from the keyboard memory location
key		dc.b 0,0
key2		dc.b 0,0
key3		dc.b 0,0

bombs_are_triggered dc.w 0	;if bombs are set to react this turn, this is set to one

email_text				dc.b	"Email:",0
email					dc.b	"gj_bomber89@hotmail.com",0
producer_text				dc.b	"Produced by:",0
producer				dc.b	"Live Bat / CCiA",0
web_site				dc.b	"http://ccia.calc.org/",0
thanx_to				dc.b	"Special Thanks To:",0,0
chris_iverson				dc.b	"Chris Ivarson - Title & Ideas",0
nightswimmer				dc.b	"Nightswimmer - Ideas",0,0
ccia					dc.b	"Carbin / SMN - CCiA",0
round_1					dc.b	"Round 1",0
round_2					dc.b	"Round 2",0
round_3					dc.b	"Round 3",0
round_4					dc.b	"Round 4",0
round_5					dc.b	"Round 5",0

starting_text			dc.b	"Starting",0,0

high_score_text			dc.b	"High Score",0,0
ask_name_text			dc.b	"Enter Your Name",0

name_text				dc.b	"Name",0,0
score_text				dc.b	"Score",0
level_text				dc.b	"Level",0

ask_save_text			dc.b	"Save Game?",0,0

startup_random_text		dc.b	"Random",0,0
startup_new_text		dc.b	"New",0,0,0
startup_options_text	dc.b	"Options",0,0,0
startup_load_text		dc.b	"Resume",0,0
startup_about_text		dc.b	"About",0
startup_game_text		dc.b	"Game:",0,0
startup_button_text		dc.b	'(',19,20,')',0
rt_left_button_text		dc.b	'(',17,18,')',0
random_level_char		dc.b	'R',0,0,0

name			dc.b	"----------",0,0
high_score1		dc.b	"----------",0,0
high_score2		dc.b	"----------",0,0
high_score3		dc.b	"----------",0,0
high_score4		dc.b	"----------",0,0
high_score5		dc.b	"----------",0,0
high_score6		dc.b	"----------",0,0
high_score7		dc.b	"----------",0,0
high_score8		dc.b	"----------",0,0
high_score1n	dc.w	0		;this contains the score data from 1 to 999
high_score2n	dc.w	0		;this contains the score data from 1 to 999
high_score3n	dc.w	0		;this contains the score data from 1 to 999
high_score4n	dc.w	0		;this contains the score data from 1 to 999
high_score5n	dc.w	0		;this contains the score data from 1 to 999
high_score6n	dc.w	0		;this contains the score data from 1 to 999
high_score7n	dc.w	0		;this contains the score data from 1 to 999
high_score8n	dc.w	0		;this contains the score data from 1 to 999
high_score1h	dc.w	0		;this contains the score data from 1,000 to 999,000
high_score2h	dc.w	0		;this contains the score data from 1,000 to 999,000
high_score3h	dc.w	0		;this contains the score data from 1,000 to 999,000
high_score4h	dc.w	0		;this contains the score data from 1,000 to 999,000
high_score5h	dc.w	0		;this contains the score data from 1,000 to 999,000
high_score6h	dc.w	0		;this contains the score data from 1,000 to 999,000
high_score7h	dc.w	0		;this contains the score data from 1,000 to 999,000
high_score8h	dc.w	0		;this contains the score data from 1,000 to 999,000
high_score1l	dc.w	0		;this contains the level that the score bearer was on
high_score2l	dc.w	0		;this contains the level that the score bearer was on
high_score3l	dc.w	0		;this contains the level that the score bearer was on
high_score4l	dc.w	0		;this contains the level that the score bearer was on
high_score5l	dc.w	0		;this contains the level that the score bearer was on
high_score6l	dc.w	0		;this contains the level that the score bearer was on
high_score7l	dc.w	0		;this contains the level that the score bearer was on
high_score8l	dc.w	0		;this contains the level that the score bearer was on

zero			dc.b	"0",0

number1_text	dc.b	"1 ",0,0
number2_text	dc.b	"2 ",0,0
number3_text	dc.b	"3 ",0,0
number4_text	dc.b	"4 ",0,0
number5_text	dc.b	"5 ",0,0
number6_text	dc.b	"6 ",0,0
number7_text	dc.b	"7 ",0,0
number8_text	dc.b	"8 ",0,0


bonus_1text		dc.b	"Extra Bomb",0,0
bonus_2text		dc.b	"Extra Life",0,0
bonus_3text		dc.b	"The Boot - Speed Up",0
bonus_4text		dc.b	"Bigger Explosions",0
bonus_5text		dc.b	"Remote Bombs",0,0
bonus_6text		dc.b	"Super Bomb",0,0
bonus_7text		dc.b	"Bonus Points",0,0
bonus_8text		dc.b	"Walk Through Walls",0,0
bonus_9text		dc.b	"Walk Through Bombs",0,0
you_text		dc.b	"The Bomber - You",0,0
bomb_text		dc.b	"The Bomb",0,0
enemy1_text		dc.b	"Enemy - The Blob",0,0
enemy2_text		dc.b	"Enemy - The Spinner",0

temp1           dc.b 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

	;this is the possibility that certain bonuses are picked when a block explodes
	;a lower number means better possibility
bonus_chance:
	dc.w	2	;extra bomb
	dc.w	4	;extra life
	dc.w	3	;the boot
	dc.w	3	;big explosions
	dc.w	6	;trigger bombs
	dc.w	9	;super bombs
	dc.w	3	;bonus score
	dc.w	5	;walk through walls
	dc.w	5	;walk through bombs



;*******************************************Reset Game Variables
;*	
;*	This is called when a new game begins
;*	
;****
reset_game_variables:
	move.w	#8,t_to_APD
	move.w	#5,t_to_key
	move.w	#10,t_to_handle
	move.w	#15,t_to_collision
	move.w	#4,bomblib::pllife
	move.w	#40,bomblib::bomblife
	move.w	#1,bomblib::bomb_exp_len
	move.w	#1,bomblib::bombsallowed
	move.w	#0,bomblib::trigger_bombs
	move.w	#0,bomblib::walk_through_bombs
	move.w	#0,bomblib::walk_through_walls
	move.w	#0,bomblib::score
	move.w	#0,bomblib::scoreh
	move.w	#1,bomblib::level
	move.w	#34,bomblib::bonus_possibility
	move.w	#16,bomblib::def_t_to_key
	move.w	#0,bomblib::game_difficulty
	rts

;*******************************************Reset Variables
;*	
;*	This is called when a player reaches a new level or when the game begins
;*	
;****
reset_variables:
	clr.w	bomblib::count_down_flag
	clr.w	bomblib::count_down_reason
	clr.w	bomblib::count_down_n
	clr.w	bomblib::enemy1count
	clr.w	bomblib::enemy2count
	clr.w	bomblib::bombcount
	clr.w	bomblib::vexpcount
	clr.w	bomblib::hexpcount
	clr.w	bomblib::xexpcount
	clr.w	bomblib::bonuscount
	clr.w	bomblib::time_to_stand
	move.w	#3,bomblib::oldmove
	clr.w	bomblib::spritelevel
	move.w	#5,bomblib::plx
	move.w	#5,bomblib::ply
	move.w	#5,bomblib::oldx
	move.w	#5,bomblib::oldy
	move.w	#3,bomblib::oldoldmove
	move.w	#0,bomblib::oldspritelevel
	SetPosInfo bomblib::plx,bomblib::ply
	rts